package com.yanzuoguang.db.db.Impl;

import com.yanzuoguang.db.db.extend.ConfigDb;
import com.yanzuoguang.util.helper.StringHelper;
import com.yanzuoguang.util.log.Log;
import org.springframework.stereotype.Component;

@Component
public class DbPrintSql {

    /**
     * 打印SQL语句
     *
     * @param sql   SQL语句
     * @param paras 参数
     */
    public void print(int row, String sql, Object... paras) {
        // 日志表忽略打印
        if (!ConfigDb.PrintSql) {
            return;
        }
        if (!StringHelper.isEmpty(ConfigDb.PrintSqlFilter)) {
            if (sql.matches(ConfigDb.PrintSqlFilter)) {
                return;
            }
        }
        // 进行SQL语句参数替换,后面增加一个空格，方便后续用正则表达式进行替换处理
        for (Object item : paras) {
            String str = StringHelper.toString(item);
            if (str == null || item instanceof Number || item.getClass().isEnum() || item instanceof Boolean) {
                if (str == null) {
                    sql = sql.replaceFirst("\\?", "null");
                } else {
                    sql = sql.replaceFirst("\\?", str);
                }

            } else {
                sql = sql.replaceFirst("\\?", "'" + str.replace("'", "''") + "'");
            }
        }
        Log.infoTag(DbExecuteImpl.class, String.format("%d row", row), sql);
    }

}
